#ifndef __seeds
#define __seeds

#include "defs.h"
#include <string.h>
#include <math.h>

class Seeds
	{
    private:
    	static int seeds[numNodes][2*numNodes];
        int mods[numNodes];
        static int current;

        bool first(int n1, int n2, int tn); // does n1 have a higher seed than n2, tn slots from now?

    public:
    	Seeds();
        static void init();
        static void regenerate_seeds();
        void tick();

        int whenIsMySlot(int tx, int rx);
        int seedOf(int n)
        	{
            if(BACKOFFSCHEME == 1)
            	{
            	if(mods[n])
                	return 0;
                else
					return seeds[n][current];
                }
            else if(BACKOFFSCHEME == 2)
	            return (seeds[n][current]/mods[n]);
            }
		// setRA (set rank attenuator)
        // when = 0 when a Tx sets its own MOD.
        // when a neighbour hears a RTS/NRA, when is set to in how many minislots
        // will the mod take effect.
        void setRA(int n, int when)
        	{
            if(BACKOFFSCHEME == 1)
            	{
            	mods[n] = WAITSLOTS+when;
                }
            else if(BACKOFFSCHEME == 2)
            	{
		        mods[n] = MAXMOD*pow(3,when);
                }
            }
    };

#endif
