#ifndef __node
#define __node

#include <stdlib.h>
#include <math.h>
#include <fstream.h>
#include "defs.h"
#include "event.h"
#include "seeds.h"
#include "log.h"

//class Event;
class EventList;
class Simulator;
//class Seeds;

class node
	{
	private:
		static int id_counter;
		static Log* log;
		static EventList* eventList;
        static Simulator* sim;

		int  id;										// unique node id
		bool trans[numNodes];							// interfering transmissions
		int  numTrans;									// number of transmissions taking place
		Event Ongoing;									// ongoing overheard transmission

        int rBT;										// Busy Tones
        Event dataW;
        Seeds ranks;

        int waitingCTS;
		bool waitingDATA;

        ifstream tgsfile;

        long nextSlotTime(long now)
        	{ return MINISLOTTIME * (now / MINISLOTTIME +1); }

	public:
		node();
        ~node();

		int  identify() { return id; }
		static void setStatic(EventList* el, Log* l, Simulator* s)
				{ eventList = el; log = l; sim = s; }
        void tick()	{ ranks.tick(); }

		void scheduleFirst();							// Schedule first transmission
		void scheduleNew(long,Event); 					// Schedule new transmission
		void notify(Event);								// Node may process event
		void receive(Event);							// Notify this node of a broadcast

        void rBusyTone(bool on);

        void setNRA_ALL(int n)	{ ranks.setRA(n,0); }	// Used for NRA GENIE
	};

#endif